<?php 
class ControllerPaymentIpay extends Controller {
	private $error = array(); 

	public function index() {
		$this->language->load('payment/ipay');

		$this->document->setTitle($this->language->get('heading_title'));

		$this->load->model('setting/setting');

		if (($this->request->server['REQUEST_METHOD'] == 'POST') && $this->validate()) {
			$this->model_setting_setting->editSetting('ipay', $this->request->post);				

			$this->session->data['success'] = $this->language->get('text_success');

			$this->redirect($this->url->link('extension/payment', 'token=' . $this->session->data['token'], 'SSL'));
		}

		$this->data['heading_title'] = $this->language->get('heading_title');

		$this->data['text_enabled'] = $this->language->get('text_enabled');
		$this->data['text_disabled'] = $this->language->get('text_disabled');
		$this->data['text_all_zones'] = $this->language->get('text_all_zones');
		$this->data['text_yes'] = $this->language->get('text_yes');
		$this->data['text_no'] = $this->language->get('text_no');

		$this->data['entry_country'] = $this->language->get('entry_country');
		$this->data['text_ke'] = $this->language->get('text_ke');
		$this->data['text_tz'] = $this->language->get('text_tz');
		$this->data['text_ug'] = $this->language->get('text_ug');
		// $this->data['text_tg'] = $this->language->get('text_tg');

		$this->data['entry_vendor'] = $this->language->get('entry_vendor');
		$this->data['entry_hash'] = $this->language->get('entry_hash');
		$this->data['entry_test'] = $this->language->get('entry_test');
		$this->data['entry_total'] = $this->language->get('entry_total');	
		$this->data['entry_order_status'] = $this->language->get('entry_order_status');		
		$this->data['entry_geo_zone'] = $this->language->get('entry_geo_zone');
		$this->data['entry_status'] = $this->language->get('entry_status');
		$this->data['entry_sort_order'] = $this->language->get('entry_sort_order');

		$this->data['button_save'] = $this->language->get('button_save');
		$this->data['button_cancel'] = $this->language->get('button_cancel');

		if (isset($this->error['warning'])) {
			$this->data['error_warning'] = $this->error['warning'];
		} else {
			$this->data['error_warning'] = '';
		}

		if (isset($this->error['vendor'])) {
			$this->data['error_vendor'] = $this->error['vendor'];
		} else {
			$this->data['error_vendor'] = '';
		}	

		if (isset($this->error['hash'])) {
			$this->data['error_hash'] = $this->error['hash'];
		} else {
			$this->data['error_hash'] = '';
		}	

		$this->data['breadcrumbs'] = array();

		$this->data['breadcrumbs'][] = array(
			'text'      => $this->language->get('text_home'),
			'href'      => $this->url->link('common/home', 'token=' . $this->session->data['token'], 'SSL'),       		
			'separator' => false
		);

		$this->data['breadcrumbs'][] = array(
			'text'      => $this->language->get('text_payment'),
			'href'      => $this->url->link('extension/payment', 'token=' . $this->session->data['token'], 'SSL'),
			'separator' => ' :: '
		);

		$this->data['breadcrumbs'][] = array(
			'text'      => $this->language->get('heading_title'),
			'href'      => $this->url->link('payment/ipay', 'token=' . $this->session->data['token'], 'SSL'),
			'separator' => ' :: '
		);

		$this->data['action'] = $this->url->link('payment/ipay', 'token=' . $this->session->data['token'], 'SSL');

		$this->data['cancel'] = $this->url->link('extension/payment', 'token=' . $this->session->data['token'], 'SSL');

		if (isset($this->request->post['ipay_country'])) {
			$this->data['ipay_country'] = $this->request->post['ipay_country'];
		} else {
			$this->data['ipay_country'] = $this->config->get('ipay_country');
		}

		if (isset($this->request->post['ipay_vendor'])) {
			$this->data['ipay_vendor'] = $this->request->post['ipay_vendor'];
		} else {
			$this->data['ipay_vendor'] = $this->config->get('ipay_vendor');
		}

		if (isset($this->request->post['ipay_hash'])) {
			$this->data['ipay_hash'] = $this->request->post['ipay_hash'];
		} else {
			$this->data['ipay_hash'] = $this->config->get('ipay_hash');
		}

		if (isset($this->request->post['ipay_test'])) {
			$this->data['ipay_test'] = $this->request->post['ipay_test'];
		} else {
			$this->data['ipay_test'] = $this->config->get('ipay_test');
		}

		if (isset($this->request->post['ipay_total'])) {
			$this->data['ipay_total'] = $this->request->post['ipay_total'];
		} else {
			$this->data['ipay_total'] = $this->config->get('ipay_total'); 
		} 

		if (isset($this->request->post['ipay_order_status_id'])) {
			$this->data['ipay_order_status_id'] = $this->request->post['ipay_order_status_id'];
		} else {
			$this->data['ipay_order_status_id'] = $this->config->get('ipay_order_status_id'); 
		}

		$this->load->model('localisation/order_status');

		$this->data['order_statuses'] = $this->model_localisation_order_status->getOrderStatuses();

		if (isset($this->request->post['ipay_geo_zone_id'])) {
			$this->data['ipay_geo_zone_id'] = $this->request->post['ipay_geo_zone_id'];
		} else {
			$this->data['ipay_geo_zone_id'] = $this->config->get('ipay_geo_zone_id'); 
		}

		$this->load->model('localisation/geo_zone');

		$this->data['geo_zones'] = $this->model_localisation_geo_zone->getGeoZones();

		if (isset($this->request->post['ipay_status'])) {
			$this->data['ipay_status'] = $this->request->post['ipay_status'];
		} else {
			$this->data['ipay_status'] = $this->config->get('ipay_status');
		}

		if (isset($this->request->post['ipay_sort_order'])) {
			$this->data['ipay_sort_order'] = $this->request->post['ipay_sort_order'];
		} else {
			$this->data['ipay_sort_order'] = $this->config->get('ipay_sort_order');
		}

		$this->template = 'payment/ipay.tpl';
		$this->children = array(
			'common/header',
			'common/footer'
		);

		$this->response->setOutput($this->render());
	}

	protected function validate() {
		if (!$this->user->hasPermission('modify', 'payment/ipay')) {
			$this->error['warning'] = $this->language->get('error_permission');
		}

		if (!$this->request->post['ipay_vendor']) {
			$this->error['vendor'] = $this->language->get('error_vendor');
		}

		if (!$this->request->post['ipay_hash']) {
			$this->error['hash'] = $this->language->get('error_hash');
		}

		if (!$this->error) {
			return true;
		} else {
			return false;
		}	
	}
}
?>