<?php
class ControllerPaymentIpay extends Controller {
	protected function index() {
		$this->data['button_confirm'] = $this->language->get('button_confirm');

		$this->load->model('checkout/order');

		$order_info = $this->model_checkout_order->getOrder($this->session->data['order_id']);

		$url_ke 				= "https://payments.ipayafrica.com/v3/ke";
		$url_tz 				= "https://payments.elipa.co.tz/v3/tz";
		$url_ug 				= "https://payments.elipa.co.ug/v3/ug";
		// $url_tg 				= "https://payments.elipa.co.ug/v3/tg";

		$ipay_url = "";

		switch ($this->config->get('ipay_country')) {
			case 'ke':
				$ipay_url 		= $url_ke;
				break;
			case 'tz':
				$ipay_url 		= $url_tz;
				break;
			case 'ug':
				$ipay_url 		= $url_ug;
				break;
			// case 'tg':
			// 	$ipay_url 		= $url_tg;
			// 	break;
			
			default:
				echo "invalid merchant country";
				exit();
				break;
		}

	    if($this->config->get('ipay_test') == '1'){
	    	$live = '0';
	    }elseif($this->config->get('ipay_test') == '0'){
	    	$live = '1';
	    }else{
	    	$live = '';
	    }
	    
	    $mm		= 1;
	    $mb		= 1;
	    $dc		= 1;
	    $cc		= 1;
		
		$oid 	= $order_info['order_id'];
    	$inv 	= $order_info['invoice_prefix'];
		$ttl 	= $order_info['total'];
		$tel 	= $order_info['telephone'];
		$eml 	= $order_info['email'];
	   	/**
	   	 * incase of any dashes in the telephone number the code below removes them
	   	 * @var [string]
	   	 */
	    $tel 	= str_replace("-", "", $tel);
	    $tel 	= str_replace( array(' ', '<', '>', '&', '{', '}', '*', "+", '!', '@', '#', "$", '%', '^', '&'), "", $tel );
	    
	    $vid	= $this->config->get('ipay_vendor');
	    //$this->console_log($vid);

	    $supported_currencies = ["KES", "TZS", "UGX", "XOF", "USD"];

	    $curr 		= "";
		if(in_array($order_info['currency_code'], $supported_currencies)){
			$curr 	= $order_info['currency_code']; 
		} else {
			echo "Unsupported currency";
			exit();
		}
	    
	    /**
	     * $p1, $p2, $p3, $p4  are optional fields. Allow sending & receiving your custom parameters
	     * Each option should not exceed 20 characters.
	     */
	    $p1		= '';
	    $p2 	= '';
	    $p3 	= ''; 
	    $p4 	= '';
	    
	    /**
	     * [$callbk holds the callback URL]
	     */
	    $callbk = $this->url->link('payment/ipay/callback', '', 'SSL');
	    
	    $cst 	= 1;
	    $crl 	= 0;
	    
	    /**
	     * [$hsh holds the merchant's secret key]
	     */
	    $hsh = $this->config->get('ipay_hash');
	    
	    //The data string values
	    $datastring =$live.$oid.$inv.$ttl.$tel.$eml.$vid.$curr.$p1.$p2.$p3.$p4.$callbk.$cst.$crl;
	    //Setting the hashing algorithm to SHA1
	    $hashid = hash_hmac('sha1', $datastring, $hsh);
	    /*URLENCODE*/
	    $cbk = urlencode($callbk);
	    $this->data['url'] = $ipay_url.'?live='.$live.'&oid='.$oid.'&inv='.$inv.'&ttl='.$ttl.'&tel='.$tel.'&eml='.$eml.'&vid='.$vid.'&p1='.$p1.'&p2='.$p2.'&p3='.$p3.'&p4='.$p4.'&crl='.$crl.'&cbk='.$cbk.'&cst='.$cst.'&curr='.$curr.'&hsh='.$hashid.'';

		if (file_exists(DIR_TEMPLATE . $this->config->get('config_template') . '/template/payment/ipay.tpl')) {
			$this->template = $this->config->get('config_template') . '/template/payment/ipay.tpl';
		} else {
			$this->template = 'default/template/payment/ipay.tpl';
		}	

		$this->render();
	}

	public function callback() {
		$this->load->model('checkout/order');

		$order_info = $this->model_checkout_order->getOrder($this->request->get['id']);

		$ipn_ke = "https://www.ipayafrica.com/ipn?";
		$ipn_tz = "https://payments.elipa.co.tz/v3/tz/ipn?";
		$ipn_ug = "https://payments.elipa.co.ug/v3/ug/ipn?";
		// $ipn_tg = "https://payments.elipa.co.ug/v3/tg/ipn?";

		$ipn_base = "";

		switch ($this->config->get('ipay_country')) {
			case 'ke':
	    		$ipn_base = $ipn_ke;
	    		break;

    		case 'tz':
	    		$ipn_base = $ipn_tz;
	    		break;

    		case 'ug':
	    		$ipn_base = $ipn_ug;
	    		break;

    		// case 'tg':
	    	// 	$ipn_base = $ipn_tg;
	    	// 	break;
	    	
	    	default:
	    		echo "Unknown country of operation";
	    		exit();
	    		break;
		}

		/**
		 * these values below are picked from the incoming URL and assigned to variables
		 * that wewill use in our security check URL
		 *
		 * The value of the parameter “vendor”, in the url being opened above, is your iPay assigned Vendor ID
		 */
		$request	= 'vendor='.urlencode($this->config->get('ipay_vendor'));
		$request 	.= '&id='.urlencode($this->request->get['id']);
		$request	.= '&ivm='.urlencode($this->request->get['ivm']);
		$request	.= '&qwh='.urlencode($this->request->get['qwh']);
		$request	.= '&afd='.urlencode($this->request->get['afd']);
		$request	.= '&poi='.urlencode($this->request->get['poi']);
		$request	.= '&uyt='.urlencode($this->request->get['uyt']);
		$request	.= '&ifd='.urlencode($this->request->get['ifd']);
		$ipnurl 	= $ipn_base.$request;
		
		/**
		 * If the payment mode is LIVE, it gets the payment status.
		 * If the plugin is on test mode, it always gives a successful response.
		 */
		$fp 		= fopen($ipnurl, "rb");
		$response	= stream_get_contents($fp, -1, -1);
		fclose($fp);

		$order_id		= $this->session->data['order_id'];
		$this->load->model('checkout/order');
		
		/**
		 * Success
		 * The transaction is valid. Therefore you can update this transaction.
		 */
		if ($response === 'aei7p7yrx4ae34') {
			if (isset($this->session->data['order_id'])) {
				$order_id = $this->session->data['order_id'];
			}else{
				echo "The system could not capture the order ID. Kindly refresh the page";
			}
			//$this->model_checkout_order->addOrderHistory($order_id, $this->config->get('ipay_order_status_id'));
			$this->model_checkout_order->confirm($order_id, $this->config->get('ipay_order_status_id'));
	
			//$this->response->redirect($this->url->link('checkout/success'));
			$this->redirect($this->url->link('checkout/success'));
		} 
	}
}
?>